import javax.media.opengl.GL;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.glu.GLU;

import classesClausius.ClausiusPoligono;
import classesClausius.ClausiusPoligono3D;
import classesClausius.ClausiusPoligonoBorda;
import classesClausius.ClausiusVetor;
import classesClausius.Poligonos;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.StringTokenizer;

public class RenderizadorTetraedro implements GLEventListener, KeyListener {
   private static final GLU glu = new GLU();
   
   static int subNumero = 0;
   static int numNewVertices;
   static int numNewFaces;
   static int faceA[];
   static int faceB[];
   static int faceC[];
   static int faceD[];
          int numNewEdges;
          int vPointFaceCount[];
          int vPointEdgeCount[];
          int ePointEdgeCount[];
   static ClausiusVetor newVPoints[];
   static ClausiusVetor newEPoints[];
   static ClausiusVetor newFPoints[];
   ClausiusVetor vPointFaceAcc[];
   ClausiusVetor vPointEdgeAcc[];
   ClausiusVetor ePointEdgeAcc[];
   public ClausiusPoligono myPoligono;
   
   static boolean subOK = false;
   static SubdivisaoTetraedro subdivisao;
   
   private float rindice = 0.0f;

   public void display(GLAutoDrawable gLDrawable) {

	   Poligonos poligono = new Poligonos();
	   poligono.carregaPoligono("tetraedro");  
	   
       final GL gl = gLDrawable.getGL();

       gl.glClear(GL.GL_COLOR_BUFFER_BIT);
       gl.glClear(GL.GL_DEPTH_BUFFER_BIT);

       gl.glPolygonMode(GL.GL_FRONT_AND_BACK, GL.GL_LINE);
       
       gl.glLoadIdentity();
       gl.glTranslatef(0.0f, 0.0f, -6.0f);
       gl.glRotatef(rindice, 1.0f, 1.0f, 1.0f);

       StringTokenizer stringtokenizer;

       if (subNumero == 0) {
           gl.glBegin(GL.GL_TRIANGLES);
           gl.glColor3f(1.0f,1.0f,0.0f);
     	  
 	      for (int i = 0; i < poligono.facesTetraedro; i++) {
 	    
 	    	  stringtokenizer = new StringTokenizer(poligono.arrayFacesTetraedro[i]);          
 	          int numeroPontos  = Integer.parseInt(stringtokenizer.nextToken());
 	          int p1            = Integer.parseInt(stringtokenizer.nextToken());
 	          int p2            = Integer.parseInt(stringtokenizer.nextToken());
 	          int p3            = Integer.parseInt(stringtokenizer.nextToken());

 	    	  gl.glVertex3f( (float)poligono.arrayVerticesTetraedro[p1].x, 
 	    			         (float)poligono.arrayVerticesTetraedro[p1].y,
 	    			         (float)poligono.arrayVerticesTetraedro[p1].z);
 	    	  
 	    	  gl.glVertex3f( (float)poligono.arrayVerticesTetraedro[p2].x, 
 				             (float)poligono.arrayVerticesTetraedro[p2].y,
 				             (float)poligono.arrayVerticesTetraedro[p2].z);
 	    	  
 	    	  gl.glVertex3f( (float)poligono.arrayVerticesTetraedro[p3].x, 
 				             (float)poligono.arrayVerticesTetraedro[p3].y,
 				             (float)poligono.arrayVerticesTetraedro[p3].z);

 	      }
       } else {
     	  
     	  gl.glBegin(GL.GL_QUADS);
           gl.glColor3f(1.0f,1.0f,0.0f);

     	  int numeroPontos  = 0;
           int p1            = 0;
           int p2            = 0;
           int p3            = 0;
           int p4            = 0;
           int aux1          = 0;

           int totalVertices = newVPoints.length + 
                               newEPoints.length + 
                               newFPoints.length;
      	 
       	  ClausiusVetor newVertices[] = new ClausiusVetor[totalVertices];

       	  int i = newVPoints.length;
           for(int j = 0; j < i; j++) {
         	  newVertices[aux1]   = new ClausiusVetor();
               newVertices[aux1].x = newVPoints[j].x;
               newVertices[aux1].y = newVPoints[j].y;
               newVertices[aux1].z = newVPoints[j].z;
               
               aux1++;
           }

           i = newEPoints.length;
           for(int k = 0; k < i; k++) {
         	  newVertices[aux1]   = new ClausiusVetor();
           	  newVertices[aux1].x = newEPoints[k].x;
               newVertices[aux1].y = newEPoints[k].y;
               newVertices[aux1].z = newEPoints[k].z;
               
               aux1++;
           }
          
           i = newFPoints.length;
           for(int l = 0; l < i; l++) {
         	  newVertices[aux1]   = new ClausiusVetor();
               newVertices[aux1].x = newFPoints[l].x;
               newVertices[aux1].y = newFPoints[l].y;
               newVertices[aux1].z = newFPoints[l].z;
               
               aux1++;
           }          

 	      for (int m = 0; m < numNewFaces; m++) {         

 	    	  numeroPontos  = 3;
 	          p1            = faceA[m];
 	          p2            = faceB[m];
 	          p3            = faceC[m];
 	          p4            = faceD[m];		          
 	          
 	    	  gl.glVertex3f( (float)newVertices[p1].x, 
 	    			         (float)newVertices[p1].y,
 	    			         (float)newVertices[p1].z);

 	    	  gl.glVertex3f( (float)newVertices[p2].x, 
  			                 (float)newVertices[p2].y,
  			                 (float)newVertices[p2].z);

 	    	  gl.glVertex3f( (float)newVertices[p3].x, 
 	    		             (float)newVertices[p3].y,
 			                 (float)newVertices[p3].z);
 	    	  
 	    	  gl.glVertex3f( (float)newVertices[p4].x, 
  		                     (float)newVertices[p4].y,
 		                     (float)newVertices[p4].z);
 	      }

       }

       gl.glEnd();
       
       gl.glFlush();
       rindice += 0.05f;
   }
      
   public void displayChanged(GLAutoDrawable gLDrawable, boolean modeChanged, boolean deviceChanged) {
   }

   public void init(GLAutoDrawable gLDrawable) {
       final GL gl = gLDrawable.getGL();
       gl.glShadeModel(GL.GL_SMOOTH);
       gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
       gl.glClearDepth(1.0f);
       gl.glEnable(GL.GL_DEPTH_TEST);
       gl.glDepthFunc(GL.GL_LEQUAL);
       gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);
       gl.glPointSize(10.0f);
       gLDrawable.addKeyListener(this);
             
   	   myPoligono = new ClausiusPoligono();
       numNewVertices = 0;
       numNewFaces = 0;
       numNewEdges = 0;
   }


public void reshape(GLAutoDrawable gLDrawable, int x, int y, int width, int height) {
       final GL gl = gLDrawable.getGL();
       if(height <= 0) {
           height = 1;
       }
       final float h = (float)width / (float)height;
       gl.glMatrixMode(GL.GL_PROJECTION);
       gl.glLoadIdentity();
       glu.gluPerspective(50.0f, h, 1.0, 1000.0);
       gl.glMatrixMode(GL.GL_MODELVIEW);
       gl.glLoadIdentity();
   }

   public void keyPressed(KeyEvent e) {
       if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
           SubdivisaoCubo.bQuit = true;
           SubdivisaoCubo.displayT.stop();
           System.exit(0);
       }
       
       if (e.getKeyCode() == KeyEvent.VK_SPACE)
       {          
           boolean flag = false;
           int totalVertices = 0;

           if (subNumero == 0) {

         	 myPoligono = null ;
         	 myPoligono = new ClausiusPoligono();
         	  
         	  Poligonos poligono = new Poligonos();
               poligono.carregaPoligono("tetraedro");
              
         	  flag = !myPoligono.read(poligono.verticesTetraedro ,
                                                 poligono.facesTetraedro, 
                                                 poligono.arrayVerticesTetraedro, 
                                                 poligono.arrayFacesTetraedro);

           } else {
         	         
         	 myPoligono = null ;
         	 myPoligono = new ClausiusPoligono();
         	  
         	 totalVertices = newVPoints.length + newEPoints.length + newFPoints.length;
         	 
              int aux1 = 0;
          	 ClausiusVetor newVertices[] = new ClausiusVetor[totalVertices];

          	 int i = newVPoints.length;         	
              for(int j = 0; j < i; j++) {
             	 newVertices[aux1]   = new ClausiusVetor();
                  newVertices[aux1].x = newVPoints[j].x;
                  newVertices[aux1].y = newVPoints[j].y;
                  newVertices[aux1].z = newVPoints[j].z;
                  
                  aux1++;
              }

              i = newEPoints.length;
              for(int k = 0; k < i; k++) {
             	 newVertices[aux1]   = new ClausiusVetor();
              	 newVertices[aux1].x = newEPoints[k].x;
                  newVertices[aux1].y = newEPoints[k].y;
                  newVertices[aux1].z = newEPoints[k].z;
                  
                  aux1++;
              }
              
              i = newFPoints.length;
              for(int l = 0; l < i; l++) {
             	 newVertices[aux1]   = new ClausiusVetor();
                  newVertices[aux1].x = newFPoints[l].x;
                  newVertices[aux1].y = newFPoints[l].y;
                  newVertices[aux1].z = newFPoints[l].z;
                  
                  aux1++;
              }

              String arrayFaces[] = new String[numNewFaces];
              for(int aux = 0; aux < numNewFaces; aux++) {
                  arrayFaces[aux] = (String)("4 " + faceA[aux] + " " + faceB[aux] + " " + faceC[aux] + " " + faceD[aux]);
              }

              int nnv            = numNewVertices;
              int nnf            = numNewFaces;
              ClausiusVetor nv[] = newVertices;
              String af[]        = arrayFaces;
              
         	 flag = !myPoligono.read(nnv, nnf, nv, af);
         	         	 
           }

           subdivide();

           subOK = true;
           subNumero++;
           
           if (subNumero == 4) {
         	  subNumero = 0;
           }
       }
   }
  
   public void subdivide()
   {
       int i = myPoligono.numPolygons;
       ClausiusPoligono3D arrayMyPolygon3d[] = myPoligono.polygons;
       int j = myPoligono.numUniqueEdges;
       ClausiusPoligonoBorda arrayMyPolygonEdge[] = myPoligono.edges;
       int k = myPoligono.numVertices;
       ClausiusVetor arrayMyVector[] = myPoligono.Vertices;
       myPoligono = null;
       numNewVertices = i + j + k;
       numNewFaces = 0;
       numNewEdges = 0;
       newVPoints = new ClausiusVetor[k];
       vPointFaceAcc = new ClausiusVetor[k];
       vPointFaceCount = new int[k];
       vPointEdgeAcc = new ClausiusVetor[k];
       vPointEdgeCount = new int[k];
       for(int l = 0; l < k; l++)
       {
           vPointFaceAcc[l] = new ClausiusVetor();
           vPointEdgeAcc[l] = new ClausiusVetor();
       }

       newEPoints = new ClausiusVetor[j];
       ePointEdgeAcc = new ClausiusVetor[j];
       ePointEdgeCount = new int[j];
       for(int i1 = 0; i1 < j; i1++)
           ePointEdgeAcc[i1] = new ClausiusVetor();

       newFPoints = new ClausiusVetor[i];
             
       for(int j2 = 0; j2 < i; j2++)
       {
           int j1 = arrayMyPolygon3d[j2].getNumEdges();
           newFPoints[j2] = new ClausiusVetor();
           for(int k2 = 0; k2 < j1; k2++)
               newFPoints[j2] = newFPoints[j2].add(arrayMyVector[arrayMyPolygon3d[j2].getVertex(k2)]);

           newFPoints[j2] = newFPoints[j2].scalarDivide(j1);
           for(int l2 = 0; l2 < j1; l2++)
           {
               int l1 = arrayMyPolygon3d[j2].getVertex(l2);
               int i2 = arrayMyPolygon3d[j2].getEdgeIndex(l2);
               vPointFaceAcc[l1] = vPointFaceAcc[l1].add(newFPoints[j2]);
               vPointFaceCount[l1]++;
               ePointEdgeAcc[i2] = ePointEdgeAcc[i2].add(newFPoints[j2]);
               ePointEdgeCount[i2]++;
           }

           numNewFaces += j1;
       }

       for(int i3 = 0; i3 < j; i3++)
       {
           ClausiusPoligonoBorda rClausiusPolygonEdge = arrayMyPolygonEdge[i3];
           ClausiusVetor rClausiusVector = arrayMyVector[rClausiusPolygonEdge.startIndex];
           ClausiusVetor rClausiusVector1 = arrayMyVector[rClausiusPolygonEdge.endIndex];
           ClausiusVetor rClausiusVector2 = rClausiusVector.add(rClausiusVector1).scalarDivide(2D);
           ePointEdgeAcc[i3] = ePointEdgeAcc[i3].add(rClausiusVector);
           ePointEdgeAcc[i3] = ePointEdgeAcc[i3].add(rClausiusVector1);
           newEPoints[i3] = ePointEdgeAcc[i3].scalarDivide(ePointEdgeCount[i3] + 2);
           vPointEdgeAcc[rClausiusPolygonEdge.startIndex] = vPointEdgeAcc[rClausiusPolygonEdge.startIndex].add(rClausiusVector2);
           vPointEdgeAcc[rClausiusPolygonEdge.endIndex] = vPointEdgeAcc[rClausiusPolygonEdge.endIndex].add(rClausiusVector2);
           vPointEdgeCount[rClausiusPolygonEdge.startIndex]++;
           vPointEdgeCount[rClausiusPolygonEdge.endIndex]++;
       }

       for(int j3 = 0; j3 < k; j3++)
       {
           double d1 = vPointFaceCount[j3];
           newVPoints[j3] = arrayMyVector[j3].scalarMultiply((d1 - 3D) / d1);
           newVPoints[j3] = newVPoints[j3].add(vPointFaceAcc[j3].scalarMultiply(1.0D / (d1 * d1)));
           newVPoints[j3] = newVPoints[j3].add(vPointEdgeAcc[j3].scalarMultiply(2D / (d1 * (double)vPointEdgeCount[j3])));
       }

       faceA = new int[numNewFaces];
       faceB = new int[numNewFaces];
       faceC = new int[numNewFaces];
       faceD = new int[numNewFaces];
       int k3 = 0;
       for(int l3 = 0; l3 < i; l3++)
       {
           int k1 = arrayMyPolygon3d[l3].getNumEdges();
           for(int i4 = 0; i4 < k1; i4++)
           {
               faceA[k3] = l3 + k + j;
               faceB[k3] = arrayMyPolygon3d[l3].getEdgeIndex(i4) + k;
               faceC[k3] = arrayMyPolygon3d[l3].getVertex((i4 + 1) % k1);
               faceD[k3] = arrayMyPolygon3d[l3].getEdgeIndex((i4 + 1) % k1) + k;
               k3++;
               numNewEdges += 4;
           }

       }

   }
   
   public void keyReleased(KeyEvent e) {
   }

   public void keyTyped(KeyEvent e) {
   }
}
