package classesClausius;

public class ClausiusEdgeBuilder
{

    public ClausiusEdgeBuilder(int i, int j)
    {
        edgeStart = new int[j];
        edgeEnd = new int[j];
        numEdges = 0;
        if(i < 10000)
        {
            buildUnique = true;
            mSize = i - 1;
            edgeMatrix = new int[mSize][];
            for(int k = 0; k < mSize; k++)
            {
                edgeMatrix[k] = new int[mSize - k];
                for(int l = 0; l < mSize - k; l++)
                    edgeMatrix[k][l] = -1;

            }

        } else
        {
            mSize = 0;
            edgeMatrix = null;
            buildUnique = false;
        }
    }

    public boolean isUnique()
    {
        return buildUnique;
    }

    public int getNumEdges()
    {
        return numEdges;
    }

    public int addEdge(int i, int j)
    {
        int k = numEdges;
        int l = i;
        int i1 = mSize - j;
        if(buildUnique && i != j)
        {
            if(edgeMatrix[l][i1] < 0)
            {
                edgeMatrix[l][i1] = numEdges;
                edgeStart[numEdges] = i;
                edgeEnd[numEdges] = j;
                k = numEdges;
                numEdges++;
            } else
            {
                k = edgeMatrix[l][i1];
            }
        } else
        {
            edgeStart[numEdges] = i;
            edgeEnd[numEdges] = j;
            k = numEdges;
            numEdges++;
        }
        return k;
    }

    public ClausiusPoligonoBorda getEdge(int i)
    {
        return new ClausiusPoligonoBorda(edgeStart[i], edgeEnd[i]);
    }

    public static final int MAX_POINT_SIZE = 10000;
    boolean buildUnique;
    int numEdges;
    int mSize;
    int edgeMatrix[][];
    int edgeStart[];
    int edgeEnd[];
}