package classesClausius;

public class ClausiusPoligono
{

    public ClausiusPoligono()
    {
        Vertices = null;
        polygons = null;
        edges = null;
        numVertices = 0;
        numPolygons = 0;
        numEdges = 0;
        numUniqueEdges = 0;
        largestPolygonSize = 0;
        validUniqueCount = true;
    }

    public ClausiusVetor getPoint(int i)
    {
        int j = edges[i / 2].startIndex;
        if(i % 2 != 0)
            j = edges[i / 2].endIndex;
        return Vertices[j];
    }

    public int getPointIndex(int i)
    {
        int j = edges[i / 2].startIndex;
        if(i % 2 != 0)
            j = edges[i / 2].endIndex;
        return j;
    }

    public boolean read(int wi, int wj, ClausiusVetor wVertices[], String wFaces[]) {
    	   	
    	boolean flag = true;

        try
        {
            int i = 0;
            int j = 0;
            int k = 0;
            int l = 0;
            double d = 0.0D;
            double d1 = 0.0D;
            double d2 = 0.0D;
            double d3 = 0.0D;
            double d4 = 0.0D;
            double d5 = 0.0D;

            ClausiusVetor arrayMyVector[] = null;
            ClausiusPoligono3D arrayMyPolygon3d[] = null;

            i = wi;
            j = wj;
                    
            if(flag && (i > 0) && (j > 0)) {
                arrayMyVector = new ClausiusVetor[i];
                arrayMyPolygon3d = new ClausiusPoligono3D[j];
            } else {
                flag = false;
            }

            if(flag)
            {
            	
                arrayMyVector[0] = new ClausiusVetor();
                
                arrayMyVector[0].x = wVertices[0].x;
                d1 = arrayMyVector[0].x;
                d = arrayMyVector[0].x;
                
                arrayMyVector[0].y = wVertices[0].y;
                d3 = arrayMyVector[0].y;
                d2 = arrayMyVector[0].y;
                
                arrayMyVector[0].z = wVertices[0].z;
                d5 = arrayMyVector[0].z;
                d4 = arrayMyVector[0].z;
                
                for(int i1 = 1; i1 < i; i1++)
                {
                    arrayMyVector[i1] = new ClausiusVetor();
                    
                    arrayMyVector[i1].x = wVertices[i1].x;
                    if(arrayMyVector[i1].x > d1) {
                        d1 = arrayMyVector[i1].x;
                    } else if(arrayMyVector[i1].x < d) {
                        d = arrayMyVector[i1].x;
                    }
                    
                    arrayMyVector[i1].y = wVertices[i1].y;
                    if(arrayMyVector[i1].y > d3) {
                        d3 = arrayMyVector[i1].y;
                    } else if(arrayMyVector[i1].y < d2) {
                        d2 = arrayMyVector[i1].y;
                    }
                    
                    arrayMyVector[i1].z = wVertices[i1].z;
                    if(arrayMyVector[i1].z > d5) {
                        d5 = arrayMyVector[i1].z;
                    } else if(arrayMyVector[i1].z < d4) {
                        d4 = arrayMyVector[i1].z;
                    }
                }
                                
            }
            
            if(flag)
            {          	
                for(int k1 = 0; k1 < j; k1++)
                {
                	String s1 = wFaces[k1];
                	
                    arrayMyPolygon3d[k1] = new ClausiusPoligono3D(s1);
                    int j1 = arrayMyPolygon3d[k1].getNumEdges();
                    
                    k += j1;
                    if(j1 > l) {
                        l = j1;
                    }
                }
            }            
                                   
            if(flag)
            {
                numVertices = i;
                numPolygons = j;
                numEdges = k;
                largestPolygonSize = l;
                Vertices = arrayMyVector;
                polygons = arrayMyPolygon3d;
                minX = d;
                maxX = d1;
                minY = d2;
                maxY = d3;
                minZ = d4;
                maxZ = d5;
                
                BuildEdges();
            }
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
            Vertices = null;
            polygons = null;
            edges = null;
            numVertices = 0;
            numPolygons = 0;
            numEdges = 0;
            numUniqueEdges = 0;
            largestPolygonSize = 0;
            maxX = 0.0D;
            minX = 0.0D;
            maxY = 0.0D;
            minY = 0.0D;
            maxZ = 0.0D;
            minZ = 0.0D;
            flag = false;
        }
        return flag;
    }
    
    private void BuildEdges()
    {
        ClausiusEdgeBuilder rClausiusEdgeBuilder = new ClausiusEdgeBuilder(numVertices, numEdges);

        for(int j = 0; j < numPolygons; j++)
        {
            int i = polygons[j].getNumEdges();
            for(int k = 0; k < i; k++)
            {
                ClausiusPoligonoBorda rClausiusPolygonEdge = polygons[j].getEdge(k);
                polygons[j].setEdgeIndex(k, rClausiusEdgeBuilder.addEdge(rClausiusPolygonEdge.startIndex, rClausiusPolygonEdge.endIndex));
            }

        }

        validUniqueCount = rClausiusEdgeBuilder.isUnique();
        numUniqueEdges = rClausiusEdgeBuilder.getNumEdges();
        edges = new ClausiusPoligonoBorda[numUniqueEdges];
        for(int l = 0; l < numUniqueEdges; l++)
            edges[l] = rClausiusEdgeBuilder.getEdge(l);

    }

    public ClausiusVetor Vertices[];
    public ClausiusPoligono3D polygons[];
    public ClausiusPoligonoBorda edges[];
    public int numVertices;
    public int numPolygons;
    public int numEdges;
    public int numUniqueEdges;
    public int largestPolygonSize;
    public double maxX;
    public double minX;
    public double maxY;
    public double minY;
    public double maxZ;
    public double minZ;
    public boolean validUniqueCount;
}