package classesClausius;

import java.util.NoSuchElementException;
import java.util.StringTokenizer;

public class ClausiusPoligono3D
{

    public ClausiusPoligono3D()
    {
    }

    public ClausiusPoligono3D(String s)
    {
        StringTokenizer stringtokenizer = new StringTokenizer(s);
        try
        {
            int i = Integer.parseInt(stringtokenizer.nextToken());
            vertexIndices = new int[i];
            edgeIndices = new int[i];
            for(int j = 0; j < i; j++)
                vertexIndices[j] = Integer.parseInt(stringtokenizer.nextToken());

        }
        catch(NumberFormatException numberformatexception) { }
        catch(NoSuchElementException nosuchelementexception) { }
        centroid = new ClausiusVetor();
    }

    public int getNumEdges()
    {
        return vertexIndices.length;
    }

    public ClausiusPoligonoBorda getEdge(int i)
    {
        int j = i + 1;
        if(i == vertexIndices.length - 1)
            j = 0;
        return new ClausiusPoligonoBorda(vertexIndices[i], vertexIndices[j]);
    }

    public int getVertex(int i)
    {
        return vertexIndices[i];
    }

    public int getEdgeIndex(int i)
    {
        return edgeIndices[i];
    }

    public void setEdgeIndex(int i, int j)
    {
        edgeIndices[i] = j;
    }

    public boolean isEdgeReversed(int i)
    {
        ClausiusPoligonoBorda rMyPolygonEdge = getEdge(i);
        return rMyPolygonEdge.startIndex != vertexIndices[i];
    }

    public void setCentroid(ClausiusVetor rClausiusVector)
    {
        centroid.x = rClausiusVector.x;
        centroid.y = rClausiusVector.y;
        centroid.z = rClausiusVector.z;
    }

    public ClausiusVetor getCentroid()
    {
        return new ClausiusVetor(centroid.x, centroid.y, centroid.z);
    }

    public String toString()
    {
        String s = String.valueOf(vertexIndices.length);
        for(int i = 0; i < vertexIndices.length; i++)
            s = s + " " + vertexIndices[i];

        return s;
    }

    ClausiusVetor normal;
    ClausiusVetor centroid;
    int vertexIndices[];
    int edgeIndices[];
}