package classesClausius;

public class ClausiusVetor implements Cloneable
{

    public ClausiusVetor()
    {
        x = 0.0D;
        y = 0.0D;
        z = 0.0D;
    }

    public ClausiusVetor(double d, double d1, double d2)
    {
        x = d;
        y = d1;
        z = d2;
    }

    public ClausiusVetor add(ClausiusVetor rClausiusVector)
    {
        return new ClausiusVetor(x + rClausiusVector.x, y + rClausiusVector.y, z + rClausiusVector.z);
    }

    public ClausiusVetor sub(ClausiusVetor rClausiusVector)
    {
        return new ClausiusVetor(x - rClausiusVector.x, y - rClausiusVector.y, z - rClausiusVector.z);
    }

    public ClausiusVetor scalarMultiply(double d)
    {
        return new ClausiusVetor(x * d, y * d, z * d);
    }

    public ClausiusVetor scalarDivide(double d)
    {
        return new ClausiusVetor(x / d, y / d, z / d);
    }

    public ClausiusVetor cross(ClausiusVetor rClausiusVector)
    {
        ClausiusVetor rClausiusVector1 = new ClausiusVetor();
        rClausiusVector1.x = y * rClausiusVector.z - z * rClausiusVector.y;
        rClausiusVector1.y = z * rClausiusVector.x - x * rClausiusVector.z;
        rClausiusVector1.z = x * rClausiusVector.y - y * rClausiusVector.x;
        return rClausiusVector1;
    }

    public double getLength()
    {
        return Math.sqrt(x * x + y * y + z * z);
    }

    public double getSquaredLength()
    {
        return x * x + y * y + z * z;
    }

    public double dot(ClausiusVetor rClausiusVector)
    {
        return x * rClausiusVector.x + y * rClausiusVector.y + z * rClausiusVector.z;
    }

    public void normalize()
    {
        double d = getLength();
        x = x / d;
        y = y / d;
        z = z / d;
    }

    public ClausiusVetor rotate(ClausiusVetor rClausiusVector, double d)
    {
        ClausiusVetor rClausiusVector1 = new ClausiusVetor();
        double d1 = Math.cos((d * 3.1415926535897931D) / 180D);
        double d2 = Math.sin((d * 3.1415926535897931D) / 180D);
        ClausiusVetor rClausiusVector2 = new ClausiusVetor();
        ClausiusVetor rClausiusVector3 = null;
        ClausiusVetor rClausiusVector4 = null;
        ClausiusVetor rClausiusVector5 = null;
        rClausiusVector5 = rClausiusVector.scalarDivide(rClausiusVector.getLength());
        if(Math.abs(dot(rClausiusVector5)) == getLength())
        {
            rClausiusVector1.x = x;
            rClausiusVector1.y = y;
            rClausiusVector1.z = z;
        } else
        {
            if(rClausiusVector.x == 0.0D && rClausiusVector.y == 0.0D)
            {
                rClausiusVector2.x = x;
                rClausiusVector2.y = y;
                rClausiusVector2.z = z;
            } else
            {
                rClausiusVector3 = cross(rClausiusVector);
                rClausiusVector3 = rClausiusVector3.scalarDivide(rClausiusVector3.getLength());
                rClausiusVector4 = rClausiusVector5.cross(rClausiusVector3);
                rClausiusVector2 = new ClausiusVetor(rClausiusVector3.dot(this), rClausiusVector4.dot(this), rClausiusVector5.dot(this));
            }
            ClausiusVetor rClausiusVector6 = new ClausiusVetor(rClausiusVector2.x * d1 - rClausiusVector2.y * -1D * d2, rClausiusVector2.x * d2 + rClausiusVector2.y * d1, rClausiusVector2.z);
            if(rClausiusVector.x == 0.0D && rClausiusVector.y == 0.0D)
            {
                rClausiusVector1.x = rClausiusVector6.x;
                rClausiusVector1.y = rClausiusVector6.y;
                rClausiusVector1.z = rClausiusVector6.z;
            } else
            {
                rClausiusVector1.x = rClausiusVector6.x * rClausiusVector3.x + rClausiusVector6.y * rClausiusVector4.x + rClausiusVector6.z * rClausiusVector5.x;
                rClausiusVector1.y = rClausiusVector6.x * rClausiusVector3.y + rClausiusVector6.y * rClausiusVector4.y + rClausiusVector6.z * rClausiusVector5.y;
                rClausiusVector1.z = rClausiusVector6.x * rClausiusVector3.z + rClausiusVector6.y * rClausiusVector4.z + rClausiusVector6.z * rClausiusVector5.z;
            }
        }
        return rClausiusVector1;
    }

    public double x;
    public double y;
    public double z;
}